dir = package.searchpath("main", package.path):match("(.*)main.lua")
dir2=package.searchpath("main",package.path):match("(.*)main.lua").."Applications/"
dir3=package.searchpath("main",package.path):match("(.*)main.lua").."launcher/"

function allSpeaks()
  local nodes = {
    "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title",
  }

  local foundNodes = {}

  for _, node in ipairs(nodes) do
    local info = service.findAccessibilityNodeInfo(node)
    if info then
      table.insert(foundNodes, info)
    end
  end

  if #foundNodes == 1 then
    -- إذا وجدنا عقدة واحدة فقط

    local textsToSpeakIds = {
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_fajr3",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_fajr1",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_dhuhr3",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_dhuhr1",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_asr3",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_asr1",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_maghrib3",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_maghrib1",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_isha3",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_isha1",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_next_prayer_title",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_next_prayer",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_analysis_info",
    }

    -- التأكد من وجود عقدة التوقف
    local stopNodeId = "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title"
    local stopNode = service.findAccessibilityNodeInfo(stopNodeId)
    if not stopNode then
      print("لم يتم العثور على عقدة التوقف.")
      return
    end

    -- جمع جميع النصوص في متغير واحد
    local allText = ""

    for _, id in ipairs(textsToSpeakIds) do
      local info = service.findAccessibilityNodeInfo(id)
      if info then
        local text = service.getText(info)
        if text then
          allText = allText .. tostring(text) .. ". " -- إضافة فاصل بين كل نص
        end
      end
    end

    -- إذا كان هناك نصوص مجمعة، قم بنطقها
    if allText ~= "" then
      service.speak(allText)
     else
      print("لم يتم العثور على نصوص للنطق.")
    end

   elseif #foundNodes == 0 then
    service.postSpeak(200,"لا توجد عقد.")
   else
    print("تم العثور على أكثر من عقدة.")
  end
end





function calendarSpeak()
  local nodes = {
    "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title",
  }

  local foundNodes = {}

  for _, node in ipairs(nodes) do
    local info = service.findAccessibilityNodeInfo(node)
    if info then
      table.insert(foundNodes, info)
    end
  end

  if #foundNodes == 1 then
    -- إذا وجدنا عقدة واحدة فقط

    local textsToSpeakIds = {
      "com.alawail.alarm.prayertimes_mobile.paid:id/toolbar_title",
    }

    -- التأكد من وجود عقدة التوقف
    local stopNodeId = "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title"
    local stopNode = service.findAccessibilityNodeInfo(stopNodeId)
    if not stopNode then
      print("لم يتم العثور على عقدة التوقف.")
      return
    end

    -- جمع جميع النصوص في متغير واحد
    local allText = ""

    for _, id in ipairs(textsToSpeakIds) do
      local info = service.findAccessibilityNodeInfo(id)
      if info then
        local text = service.getText(info)
        if text then
          allText = allText .. tostring(text) .. ". " -- إضافة فاصل بين كل نص
        end
      end
    end

    -- إذا كان هناك نصوص مجمعة، قم بنطقها
    if allText ~= "" then
      service.speak(allText)
     else
      print("لم يتم العثور على نصوص للنطق.")
    end

   elseif #foundNodes == 0 then
    service.postSpeak(200,"لا توجد عقد.")
   else
    print("تم العثور على أكثر من عقدة.")
  end
end










function remainingSpeaks()
  local nodes = {
    "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title",
  }

  local foundNodes = {}

  for _, node in ipairs(nodes) do
    local info = service.findAccessibilityNodeInfo(node)
    if info then
      table.insert(foundNodes, info)
    end
  end

  if #foundNodes == 1 then
    -- إذا وجدنا عقدة واحدة فقط

    local textsToSpeakIds = {
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_next_prayer_title",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_next_prayer",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title",
      "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain",
    }

    -- التأكد من وجود عقدة التوقف
    local stopNodeId = "com.alawail.alarm.prayertimes_mobile.paid:id/textView_ikama_remain_title"
    local stopNode = service.findAccessibilityNodeInfo(stopNodeId)
    if not stopNode then
      print("لم يتم العثور على عقدة التوقف.")
      return
    end

    -- جمع جميع النصوص في متغير واحد
    local allText = ""

    for _, id in ipairs(textsToSpeakIds) do
      local info = service.findAccessibilityNodeInfo(id)
      if info then
        local text = service.getText(info)
        if text then
          allText = allText .. tostring(text) .. ". " -- إضافة فاصل بين كل نص
        end
      end
    end

    -- إذا كان هناك نصوص مجمعة، قم بنطقها
    if allText ~= "" then
      service.speak(allText)
     else
      print("لم يتم العثور على نصوص للنطق.")
    end

   elseif #foundNodes == 0 then
    service.postSpeak(200,"لا توجد عقد.")
   else
    print("تم العثور على أكثر من عقدة.")
  end
end










function nearbyMosques()
  require 'import'
  import "android.content.Context"
  import "android.content.Intent"
  import "android.provider.Settings"
  import "android.location.LocationManager"
  locationManager = this.getSystemService(Context.LOCATION_SERVICE)
  gpsEnabled = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)
  if not gpsEnabled then
    intent = Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS)
    this.startActivity(intent)
    service.click({{"#switch_widget#1>5$300", "%Retour$300", "#imageView_newItems>30$100","#idButtonNearbyModques>10",}})
   else
    service.click({{"#imageView_newItems$100","#idButtonNearbyModques>10",}})
  end
end






if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "جي بي تي" then
            dofile(dir.. "ChatGPT.lua")
            return
           elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "الاوامر الرئيسيه" then
            dofile(dir.. "MainVoiceCommands.lua")
            return
           elseif text:lower() == "مساعد الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
            return
           elseif text:lower() == "وصف الشاشه" or text:lower() == "مساعد شاشه الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
            return
           elseif text == "الاملاء بالعربيه" then
            dictAr()
            return
         elseif text:lower() == "الباحث القراني" or text:lower() == "البحث في القران" then
          dofile(dir.. "searchQuran.lua")
          return


           elseif text == "جميع الصلوات" then
            allSpeaks()
            return
           elseif text == "الصلاه القادمه" then
            remainingSpeaks()
            return
           elseif text == "التقويم" then
            calendarSpeak()
            return
           elseif text == "المساجد القريبه" then
            nearbyMosques()
            return
           elseif text == "اوقات الصيام والليل" then
            task(1600, function()
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  service.click({{"%Retour",}})
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end)
            service.click({{"#com.alawail.alarm.prayertimes_mobile.paid:id/imageView_analysis", "%Lire l'écran complet",}})
            return

           elseif text == "مشاركه المواقيت" then
            service.click({{"#com.alawail.alarm.prayertimes_mobile.paid:id/imageView_m_hijri"}})
            return

           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف
تحديث المفتاح
المساعد السريع
مساعد الهاتف
وصف الشاشة، أو مساعد شاشة الهاتف
جي بي تي 
الأوامر الرئيسية
الإملاء بالعربية
الباحث القرآني أو البحث في القرآن
جميع الصلوات  
الصلاة القادمة  
التقويم  
المساجد القريبة  
أوقات الصيام والليل  
مشاركة المواقيت  
المساعدة
المساعَدة العامة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("assalatuNoor")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end