require "import"
import "com.androlua.*"
import "android.content.Intent"
import "android.os.Handler"
import "android.os.Looper"
import "java.io.File"

local renamedFilePath = ""

task(300, function()
  local datetime = os.date("%d-%m-%Y %H:%M")
  local pathFrom = "/storage/emulated/0/Documents/الإملاء المريح"
  local pathTo = "/storage/emulated/0/Documents"
  LuaUtil.zip(pathFrom, pathTo)
end)

task(3000, function()
  local datetime = os.date("%d-%m-%Y_%H_%M")
  local oldPath = "/storage/emulated/0/Documents/الإملاء المريح.zip"
  local newPath = "/storage/emulated/0/Documents/نصوص_الإملاء_المريح_" .. datetime .. ".zip"

  local success, err = os.rename(oldPath, newPath)

  if success then
    service.speak("تم حفظ جميع الملفات النصية في ملف مضغوط بإسم:  نصوص_الإملاء_المريح_" .. datetime .. ".zip".. "والآن يمكنك مشاركته مع تطبيق خارجي.")
    renamedFilePath = newPath
  else
    service.speak("حدث خطأ أثناء إعادة تسمية الملف: " .. err)
  end
end)

task(5000, function()
  local handler = Handler(Looper.getMainLooper())

  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      if renamedFilePath ~= "" then
        local file = File(renamedFilePath)
        local uri = this.getUriForFile(file)

        local intent = Intent(Intent.ACTION_SEND)
        intent.setType("application/zip")
        intent.putExtra(Intent.EXTRA_STREAM, uri)
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)

        local chooser = Intent.createChooser(intent, "مشاركة الملف مع...")
        chooser.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
        this.startActivity(chooser)
      else
        service.speak("لا يوجد ملف للمشاركة.")
      end
    else
      handler.postDelayed(checkSpeakingStatus, 1000)
    end
  end

  handler.postDelayed(checkSpeakingStatus, 1500)
end)