utf8 = require("utf8")

function removeBracketInfoFromLines(text)
    local modified = false
    local lines = {}
    for line, ending in text:gmatch("([^\r\n]*)([\r\n]?)") do
        if line == "" and ending == "" then break end
        line = line:gsub("  %[", ". [")
        -- إذا السطر يحتوي على معلومات داخل أقواس مربعة، نحذفه كامل
        if line:find("%[.-%]") then
            modified = true
            -- ما نضيفش السطر للقائمة
        else
            table.insert(lines, line .. ending)
        end
    end
    return table.concat(lines), modified
end

local node = service.getEditText()
if node then
    local text = service.getText(node)
    local newText, changed = removeBracketInfoFromLines(text)
    if changed then
        service.setText(node, newText .. "\n")
        service.postSpeak(200,"تم حذف  الآيات.")
    else
        service.postSpeak(200,"لا توجد آيات لحذفها.")
    end
else
    service.speak("لا يوجد مربع تحرير في الشاشة الحالية.")
end