  if service.getEditText() then
    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local handler = Handler(Looper.getMainLooper())
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local vibrator = activity.getSystemService("vibrator")

    -- local aiResponseReceived = false -- No longer needed as we're not waiting for AI response

    local function urlEncode(text)
      text = tostring(text)
      text = text:gsub("\n", "\r\n")
      text = text:gsub("([^%w %-%_%.%~])", function(c)
        return string.format("%%%02X", string.byte(c))
      end)
      text = text:gsub(" ", "+")
      return text
    end

    local function startVoiceRecognition(activity)
      local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
      intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

      handler.postDelayed(function()
        vibrator.vibrate(50)
      end, 350)

      local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params) end,

        onResults = function(params)
          local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
          local text = results.get(0)

          handler.postDelayed(function()
            vibrator.vibrate(100)
          end, 350)

          if text and text ~= "" then

            if text:lower() == "المساعده العامه" then
              dofile(dir.. "help.lua")
              return
             elseif text:lower() == "جي بي تي" then
              dofile(dir.. "ChatGPT.lua")
              return
             elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  quickAssist()
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
              return
             elseif text:lower() == "تحديث المفتاح" then
              updateApiKey()
              return
             elseif text:lower() == "الاوامر الرئيسيه" then
              dofile(dir.. "MainVoiceCommands.lua")
              return
             elseif text:lower() == "مساعد الهاتف" then
              require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
              service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
              return
             elseif text:lower() == "شاشه الهاتف" or text:lower() == "مساعد شاشه الهاتف" then
              require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
              service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
              return




             elseif text:lower() == "تحديث المفتاح" then
              updateApiKey()
              return
             elseif text:lower() == "الاملاء بالفصحى" then
              converAr()
              return
             elseif text == "تعديل القاموس" then
              dofile(dir.. "dictionary.lua")
              return
             elseif text:lower() == "الاملاء بالعربيه" then
              this.postSpeak(200,"عربي. ")
              task(1600, function()
                dictAr()
              end)
              return
             elseif text:lower() == "الاملاء بالانجليزيه" then
              this.postSpeak(200,"English. ")
              task(1600, function()
                dictEn()
              end)
              return
             elseif text:lower() == "الاملاء بالفرنسيه" then
              this.postSpeak(200,"Français. ")
              task(1600, function()
                dictFr()
              end)
              return

             elseif text:lower() == "الترجمه الانجليزيه" then
              this.postSpeak(200,"الإنجليزية. . ")
              task(1200, function()
                transEn()
              end)
              return
             elseif text:lower() == "الترجمه الفرنسيه" or text:lower() == "الترجمه الى الفرنسيه" then
              this.postSpeak(200,"الفرنسية. . ")
              task(1200, function()
                transFr()
              end)
              return
             elseif text:lower() == "الترجمه الالمانيه" then
              this.postSpeak(200,"الألمانية. . . ")
              task(1200, function()
                transDe()
              end)
              return
             elseif text:lower() == "الترجمه الاسبانيه" then
              this.postSpeak(200,"الإسبانية. ")
              task(1200, function()
                transEs()
              end)
              return
             elseif text:lower() == "الترجمه الايطاليه" then
              this.postSpeak(200,"الإيطالية. ")
              task(1200, function()
                transIt()
              end)
              return
             elseif text:lower() == "الترجمه التركيه" then
              this.postSpeak(200,"التركية. . ")
              task(1200, function()
                transTr()
              end)
              return
             elseif text:lower() == "الترجمه الصينيه" then
              this.postSpeak(200,"الصينية. . ")
              task(1200, function()
                transZh()
              end)
              return
             elseif text:lower() == "الترجمه الهنديه" then
              this.postSpeak(200,"الهنديةية. . ")
              task(1200, function()
                transHi()
              end)
              return
             elseif text:lower() == "الترجمه الفارسيه" then
              this.postSpeak(200,"الفارسية. . ")
              task(1200, function()
                transFa()
              end)
              return
             elseif text:lower() == "احصائيات" then
              service.getText(node)
              dofile(dir.. "analyzeText.lua")

              return
             elseif text:lower() == "مراجعه" then
              if service.getEditText() then
                local node = service.getEditText()
                local text = service.getText(node)
                this.postSpeak(200,text)
                local function checkSpeakingStatus()
                  if not service.isSpeaking() then
                    startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                   else
                    handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                  end
                end
                handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return
             elseif text:lower() == "تهجئه" then
              if service.getEditText() then
                task(200, function()
                  spellText()
                end)
                local function checkSpeakingStatus()
                  if not service.isSpeaking() then
                    startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                   else
                    handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                  end
                end
                handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
               else
                this.postSpeak(200, "لا يوجد مربع تحرير. ")
              end
              return
             elseif text:lower() == "ترجمه" then if service.getEditText() then
              local node = service.getEditText()
              service.execute("翻译",node)
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
             else
              this.postSpeak(200, "لا يوجد مربع تحرير. ")
            end
            return

           elseif text:lower() == "الحافظه" then
            service.execute("presse-papier")
            return
           elseif text:lower() == "المفضله" then
            service.execute("Favoris")
            return
           elseif text:lower() == "اضافه الى الحافظه" then
            copyresult()
            task(1600, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "اضافه الى السابق" or text:lower() == "اضافه الى السابق في الحافظه"then
            appendCopyresult()
            task(1600, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "اضافه الى المفضله" then
            addFav()
            task(1600, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "اضافه الى ملف" then
            dofile(dir.. "saveToFile.lua")
            return
           elseif text:lower() == "تصدير الملفات" then
            dofile(dir.. "compressTheFileAndSendIt.lua")
            return
           elseif text:lower() == "اضافه الى الملاحظات" then
            dofile(dir.. "saveCloudNote.lua")
            return
           elseif text:lower() == "ملاحظه جديده" then
            dofile(dir.. "newCloudNote.lua")
            return
           elseif text:lower() == "ملف جديد" then
            dofile(dir.. "newFile.lua")
            return
           elseif text:lower() == "مشاركه" then
            share()
            return
           elseif text:lower() == "لصق الجواب الاخير" then
            pasteLastAnswer()
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity)
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "لصق" then
            service.paste()
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return

           elseif text:lower() == "تصحيح" then
            correctText()
            return
           elseif text:lower() == "تشكيل" then
            correctAndTashkeelText()
            return
           elseif text:lower() == "الوجوه التعبيريه" then
            addEmojis()
            return

           elseif text:lower() == "الحرف التالي" then
            task(200, function()
              service.execute("下个字符")
            end)
            task(1000, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "الحرف السابق" then
            task(200, function()
              service.execute("上个字符")
            end)
            task(1000, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "الكلمه التاليه" then
            task(200, function()
              service.execute("下个字词")
            end)
            task(1000, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "الكلمه السابقه" then
            task(200, function()
              service.execute("上个字词")
            end)
            task(1000, function()
              startVoiceRecognition(activity)
            end)
            return
           elseif text:lower() == "الجمله التاليه" then
            task(200, function()
              service.execute("下个句子")
            end)
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "الجمله السابقه" then
            task(200, function()
              service.execute("上个句子")
            end)
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "الفقره التاليه" then
            task(200, function()
              service.execute("下个段落")
            end)
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "الفقره السابقه" then
            task(200, function()
              service.execute("上个段落")
            end)
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "العنصر الاول" then
            task(200, function()
              service.execute("开头")
            end)
            return
           elseif text:lower() == "العنصر الاخير" then
            task(200, function()
              service.execute("结尾")
            end)
            return
           elseif text:lower() == "وضع التحديد" then task(200, function()
            service.execute("选择模式")
          end)
          task(1600, function()
            startVoiceRecognition(activity)
          end)
          return

         elseif text:lower() == "الباحث القراني" or text:lower() == "البحث في القران" then
          dofile(dir.. "searchQuran.lua")
          return
         elseif text:lower() == "ادوات التعديل" then dofile(dir.. "editingTools.lua")
          return
         elseif text:lower() == "تعديل" or text:lower() == "تعديل النص" or text:lower() == "قائمه التعديل" then
          editText()
          return
         elseif text:lower() == "ازاله الايات" then
          dofile(dir.. "deleteAllVerses.lua")
          return
         elseif text:lower() == "ازاله معلومات الايات" then
          dofile(dir.. "removeBracketInfoFromLines.lua")
          return
         elseif text:lower() == "ازاله علامات الترقيم" then
          dofile(dir.. "removePunctuation.lua")
          return
         elseif text:lower() == "ازاله النجوم" then
          removeAsterisks()
          return
         elseif text:lower() == "ازاله حرف" then if service.getEditText() then
          backspace()
          task(1500, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير.")
        end
        return
       elseif text:lower() == "ازاله كلمه" then
        if service.getEditText() then
          backspaceWord()
          task(1500, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير.")
        end
        return
       elseif text:lower() == "ازاله جمله" then
        if service.getEditText() then
          backspaceSentence()
          local function checkSpeakingStatus()
            if not service.isSpeaking() then
              startVoiceRecognition(activity) -- استئناف الإملاء الصوتي
             else
              handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
            end
          end
          handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
         else
          this.postSpeak(200, "لا يوجد مربع تحرير.")
        end
        return
       elseif text:lower() == "تراجع" then
        if service.getEditText() then
          this.postSpeak(200, "أَعدِ المحاولة.")
          undo()
          task(1500, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير.")
        end
        return
       elseif text:lower() == "ازاله النص المحدد" then
        removeSelectedText()
        return
       elseif text:lower() == "جديد" then
        service.execute("清空")
        task(1600, function()
          startVoiceRecognition(activity)
        end)
        return
       elseif text:lower() == "دمج الاسطر" then
        task(200, function()
          mergeLines()
        end)
        task(1000, function()
          startVoiceRecognition(activity)
        end)
        return

       elseif text:lower() == "ادراج التاريخ الهجري" then
        dofile(dir.. "insertHijriDate.lua")
        return
       elseif text:lower() == "ادراج التاريخ الميلادي" then
        dofile(dir.. "insertGregorianDate.lua")
        return
       elseif text:lower() == "علامه الموضوع" then
        dofile(dir.. "hashtag.lua")
        return
       elseif text:lower() == "سطر جديد" then service.paste("\n")
        task(1000, function()
          startVoiceRecognition(activity)
        end)
        return
       elseif text:lower() == "شرطتين" then
        service.paste("-- ")
        this.postSpeak(200, "شَرْطَتَيْنْ. ")
        task(1500, function()
          startVoiceRecognition(activity)
        end)
        return
       elseif text:lower() == "شرطه" then
        service.paste("-")
        this.postSpeak(200, "- ")
        task(1500, function()
          startVoiceRecognition(activity)
        end)
        return
       elseif text:lower() == "نقطه" then
        if service.getEditText() then
          point()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فاصله" then
        if service.getEditText() then
          comma()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "نقطتين" then
        if service.getEditText() then
          Colon()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فاصله منقوطه" then
        if service.getEditText() then
          Semicolon()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "استفهام" then
        if service.getEditText() then
          Question()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "تعجب" then
        if service.getEditText() then
          Exclamation()
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فتح قوس" then
        if service.getEditText() then
          service.insertText(node, "(")
          this.postSpeak(200, "(")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "غلق قوس" then
        if service.getEditText() then
          service.insertText(node, ")")
          this.postSpeak(200, ")")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فتح قوس مزخرف" then
        if service.getEditText() then
          service.insertText(node, "{")
          this.postSpeak(200, "{")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "غلق قوس مزخرف" then
        if service.getEditText() then
          service.insertText(node, "}")
          this.postSpeak(200, "}")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فتح قوسين مزخرفين" then
        if service.getEditText() then
          service.insertText(node, "{{")
          this.postSpeak(200, "فَتْحُ قَوْسَيْنِ مُزَخْرَفَيْنْ.")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "غلق قوسين مزخرفين" then
        if service.getEditText() then
          service.insertText(node, "}}")
          this.postSpeak(200, "غَلْقُ قَوْسَيْنِ مُزَخْرَفَيْنْ.")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فتح قوس مربع" then
        if service.getEditText() then
          service.insertText(node, "[")
          this.postSpeak(200, "[")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "غلق قوس مربع" then
        if service.getEditText() then
          service.insertText(node, "]")
          this.postSpeak(200, "]")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "فتح قوسين مربعين" then
        if service.getEditText() then
          service.insertText(node, "[[")
          this.postSpeak(200, "فَتْحُ قَوْسَيْنِ مُرَبَّعَيْنِ.")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return
       elseif text:lower() == "غلق قوسين مربعين" then
        if service.getEditText() then
          service.insertText(node, "]]")
          this.postSpeak(200, "غَلْقُ قَوْسَيْنِ مُرَبَّعَيْنِ.")
          task(1800, function()
            startVoiceRecognition(activity)
          end)
         else
          this.postSpeak(200, "لا يوجد مربع تحرير. ")
        end
        return



       elseif text:lower() == "ارسال" or text:lower() == "ارسل" or text:lower() == "تطبيق" then
        dofile(dir.. "send.lua")
        return
       elseif text:lower() == "توقف قليلا" then
        this.postSpeak(200,"إرتح قليلاً، ثم إستأنِفِ الإملاءَ بعدَ سماع النغمة. ")
        handler.postDelayed(function()
          startVoiceRecognition(activity)
        end, 15000)
        return
       elseif text:lower() == "توقف" then
        recognizer.stopListening()
        recognizer.destroy()
        recognizer = nil
        this.postSpeak(200,"تم إيقافُ الإملاءِ الصوتي. ")
        return
       elseif text:lower() == "الغاء الاملاء" then
        this.postSpeak(1200,"تم إيقافُ الإملاءِ الصوتي. ")
        service.execute("清空")
        return
      end

      -- This entire section is removed to disable the correction feature
      --[[
      aiResponseReceived = false

      local inputText = "Only correct the grammatical and spelling errors in the following text. Keep the original language unchanged. If there are some English or French words written in Arabic, write them in their original language (English or French). Also, if any Latin words are found written in Arabic, convert them to Latin even if they are in the middle of Arabic text. Do not add any greetings, responses, or explanations. Do not respond to welcome texts such as greetings, especially if the text contains only one or two words. If the text contains nothing at all, do not respond at all. Do not consider the text a question, and therefore do not respond to it; just correct it only.  Return only the corrected text: " .. text
      local requestBody = cjson.encode({
        contents = {{ parts = {{ text = inputText }} }}
      })

      local headers = {
        ["Content-Type"] = "application/json",
        ["x-goog-api-key"] = geminiApiKey
      }

      Http.post(geminiApiEndpoint, requestBody, headers, function(status, data)
        if status == 200 then
          local response = cjson.decode(data)
          if response and response.candidates and response.candidates[1] and response.candidates[1].content and response.candidates[1].content.parts and response.candidates[1].content.parts[1] and response.candidates[1].content.parts[1].text then
            local cleanedData = response.candidates[1].content.parts[1].text
            local node = service.getEditText()
            local finalText = applyReplacements(cleanedData)

            service.insertText(node, finalText)
            this.speak(finalText)
           else
            this.postSpeak(500, "تنسيق استجابة Gemini 2.0 Flash غير متوقع.")
            print("Gemini API Response Data:", data)
            local node = service.getEditText()
            service.insertText(node, text .. " \n")
          end
         else
          this.postSpeak(500, "حدث خطأ في الاتصال بـ Gemini 2.0 Flash API: " .. status)
          print("Gemini API Error Status:", status)
          print("Gemini API Error Data:", data)
          local node = service.getEditText()
          service.insertText(node, text .. " \n")
        end
        aiResponseReceived = true
      end)

      local function checkSpeakingStatus()
        if not service.isSpeaking() and aiResponseReceived then
          startVoiceRecognition(activity)
         else
          handler.postDelayed(checkSpeakingStatus, 1000)
        end
      end

      handler.postDelayed(checkSpeakingStatus, 500)
      --]]

      -- This is the new part: directly insert the recognized text
      local node = service.getEditText()
      service.insertText(node, text)
      this.speak(text) -- Optionally speak the recognized text

      -- Immediately restart voice recognition after inserting the text
      handler.postDelayed(function()
        startVoiceRecognition(activity)
      end, 500)

     else
      startVoiceRecognition(activity)
    end
  end,

  onError = function(error)
    this.postSpeak(200, "لم يتم التقاط أي نص.")
  end
})

recognizer.setRecognitionListener(recognitionListener)
recognizer.startListening(intent)
end

startVoiceRecognition(activity)
else
local handler = Handler(Looper.getMainLooper())
this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
local function checkSpeakingStatus()
  if not service.isSpeaking() then
    quickAssist()
   else
    handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
  end
end
handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية

end
 