require "import"

if service.getEditText() then
  local node = service.getEditText()
  task(500, function()

    -- الحصول على التاريخ الميلادي من os.date
    local g_day = tonumber(os.date("%d"))
    local g_month = tonumber(os.date("%m"))
    local g_year = tonumber(os.date("%Y"))

    -- دالة التحويل إلى هجري مع تصحيح يدوي
    function toHijri(g_year, g_month, g_day)
      -- التعديلات اليدوية
      local dayOffset = -1  -- غيّر هذه القيمة إذا احتجت تصحيح التاريخ (مثلاً -1 أو +1)
      local monthOffset = 0 -- لتعديل الشهر (نادراً ما تحتاجه)

      local jd = (1461 * (g_year + 4800 + (g_month - 14) // 12)) // 4 +
                 (367 * (g_month - 2 - 12 * ((g_month - 14) // 12))) // 12 -
                 (3 * ((g_year + 4900 + (g_month - 14) // 12) // 100)) // 4 + 
                 g_day - 32075

      jd = jd + dayOffset

      local l = jd - 1948440 + 10632
      local n = (l - 1) // 10631
      l = l - 10631 * n + 354
      local j = ((10985 - l) // 5316) * ((50 * l) // 17719) + (l // 5670) * ((43 * l) // 15238)
      l = l - ((30 - j) // 15) * ((17719 * j) // 50) - (j // 16) * ((15238 * j) // 43) + 29

      local h_month = (24 * l) // 709
      local h_day = l - (709 * h_month) // 24
      local h_year = 30 * n + j - 30

      h_month = h_month + monthOffset
      if h_month > 12 then
        h_month = h_month - 12
        h_year = h_year + 1
      elseif h_month < 1 then
        h_month = h_month + 12
        h_year = h_year - 1
      end

      return h_day, h_month, h_year
    end

    -- أسماء الأشهر الهجرية
    local hijriMonths = {
      "محرم", "صفر", "ربيع الأول", "ربيع الآخر", "جمادى الأولى", "جمادى الآخرة",
      "رجب", "شعبان", "رمضان", "شوال", "ذو القعدة", "ذو الحجة"
    }

    local h_day, h_month, h_year = toHijri(g_year, g_month, g_day)
    local hijriDate = string.format("%02d-%s-%d", h_day, hijriMonths[h_month], h_year)

    -- إدراج التاريخ الهجري في بداية النص
    local currentText = service.getText(node)
    service.insertText(node, hijriDate .. "\n" )
    service.speak(hijriDate)

  end)
else
  service.postSpeak(200, "لا يوجد مربع تحرير.")
end