require 'import'
import "android.app.ActivityManager"
import "android.content.Context"

-- تشغيل أوامر shell
function runShell(cmd)
  local p = io.popen(cmd)
  local result = p:read("*a")
  p:close()
  return result
end

-- تحويل الكيلوبايت إلى جيجابايت
function toGB(kb)
  local gb = tonumber(kb) / (1024 * 1024)
  return string.format("%.2f", gb) .. " gb"
end

-- تحليل معلومات التخزين df
function parseDF(output)
  for line in output:gmatch("[^\r\n]+") do
    if line:find("/storage/emulated") then
      local parts = {}
      for word in line:gmatch("%S+") do
        table.insert(parts, word)
      end

      return {
        total = toGB(parts[2]),
        used = toGB(parts[3]),
        available = toGB(parts[4]),
        percent = parts[5]
      }
    end
  end
  return nil
end

-- الحصول على نسبة استخدام الذاكرة العشوائية (الرام)
function getMemoryUsage()
  local activity = this
  local activityManager = activity.getSystemService(Context.ACTIVITY_SERVICE)
  local memoryInfo = ActivityManager.MemoryInfo()
  activityManager.getMemoryInfo(memoryInfo)

  local total = memoryInfo.totalMem
  local available = memoryInfo.availMem
  local used = total - available
  local percent = math.floor((used / total) * 100)

  return percent
end

-- الوظيفة الرئيسية للنطق
function speakStorageAndMemory()
  -- معلومات التخزين
  local storageOutput = runShell("df /storage/emulated/0")
  local storageInfo = parseDF(storageOutput)

  if storageInfo then
    service.appendSpeak2(
      "معلومات التخزين: الإجمالي: " .. storageInfo.total ..
      "، المستخدَم: " .. storageInfo.used ..
      "، المتوفر: " .. storageInfo.available ..
      "، النسبة: " .. storageInfo.percent
    )
  else
    service.appendSpeak2("فشل في تحليل معلومات التخزين.")
  end

  -- الرام فقط
  local ramPercent = getMemoryUsage()
  service.appendSpeak2("نسبة استخدام الذاكرة العشوائية: " .. ramPercent .. " بالمئة")
end

-- تنفيذ
speakStorageAndMemory()