require "import"
import "android.widget.*"
import "android.preference.*"

Shared = service.getSharedPreferences("auto_enter_key", service.MODE_PRIVATE)
Share = Shared.edit()

api_key = Shared.getString("api_key_id", "لا توجد كلمة مرور.")

local d


function autoEnterKey()
  local nodes = {
    "com.android.systemui:id/keyguardMessageWidget",
    "com.android.systemui:id/pinEntry",
    "com.android.systemui:id/keyguard_message_area",
"com.android.systemui:id/bouncer_message_area_title",
    "com.android.settings:id/header_text"
  }

  local found = false

  for i, id in ipairs(nodes) do
    local node = service.findAccessibilityNodeInfo(id)
    if node then
      task(800, function()
        local code = Shared.getString("api_key_id", "")
        if code ~= "" then
          local func, err = loadstring(code)
          if func then
            local ok, result = pcall(func)
            if not ok then
              print("خطأ أثناء التنفيذ:", result)
            end
          else
            print("خطأ في الكود:", err)
          end
        else
          service.postSpeak(200, "لم تقم بتعيين كلمة المرور. يرجى تعيينها.")
          task(3400, function()
            prepareKey()
          end)
        end
      end)
      found = true
      break
    end
  end

  if not found then
if service.click({{"<#com.android.systemui:id/tip_tex$500","%Glisser l'élément vers le haut", }})
elseif service.click({{"إلغاء قفل",}})
    elseif service.click({{"%上滑翻页",}})
end
    task(700, function()
      autoEnterKey()
    end)
  end
end

function prepareKey()
  local layout = {
    LinearLayout,
    orientation = "vertical",
    {
      TextView,
      text = (api_key ~= "لا توجد كلمة مرور.") and api_key or "",
      id = "title",
      layout_width = "fill",
    },
    {
      EditText,
      layout_width = "fill",
      id = "edit",
      hint = "أدخل الخطوات، كل خطوة في سطر"
    },
    {
      Button,
      layout_width = "fill",
      text = "حفظ",
      onClick = function()
        local input = edit.text
        if input ~= "" then
          local lines = {}
          for line in input:gmatch("[^\r\n]+") do
            table.insert(lines, '"' .. line .. '>10$20"')
          end
          local joined = table.concat(lines, ",\n")
          local finalCode = "function autoEnterKey()\nservice.click({{\n" .. joined .. "\n}})\nend\nautoEnterKey()"
          Share.putString("api_key_id", finalCode).apply()
          title.text = finalCode
          edit.text = ""
          service.postSpeak(200, "تم حفظ كلمة المرور بنجاح.")
        else
          title.text = "لا توجد كلمة مرور."
          service.postSpeak(200, "لا يوجد محتوى لحفظه.")
        end
      end
    },
    {
      Button,
      layout_width = "fill",
      text = "تشغيل كلمة المرور",
      onClick = function()
        task(200, function()
          autoEnterKey()
        end)
        d.dismiss()
      end
    },
    {
      Button,
      layout_width = "fill",
      text = "حذف كلمة المرور",
      onClick = function()
        Share.remove("api_key_id").apply()
        title.text = "لا توجد كلمة مرور."
        service.postSpeak(200, "تم حذف كلمة المرور.")
        edit.text = ""
      end
    },
    {
      Button,
      layout_width = "fill",
      text = "مساعدة",
      onClick = function()
helpKy()
      end
    },
    {
      Button,
      layout_width = "fill",
      text = "خروج",
      onClick = function()
        d.dismiss()
      end
    }
  }

  d = LuaDialog(this)
  d.View = loadlayout(layout)
  d.show()
end


function helpKy()
            local helpText = [[
من خلال هذه النافذة يمكننا إدارة كلمة المرور الخاصة بقفل الهاتف.
إذا تم تعيين كلمة مرور سابقا فإنها ستظهر  أعلى الشاشة قبل مربع التحرير.
وإلا سيظهر مربع التحرير مباشرة أعلى الشاشة.
عند إدخال كلمة المرور، يجب أن ندخل كل عنصر منها في سطر مستقل، وبعد العنصر الأخير لا نضيف سطرا جديدا.
وإذا كنا نفتح القفل في هاتفنا بإدخال كلمة المرور والضغط على زر بعد إدخال كلمة المرور، فيجب أيضا أن نضيف هذا الزر في سطر جديد بعد إدخال عناصر كلمة المرور.
إما ان نضيف هذا الزر باسمه او باسم العقدة الخاصة به.
بعد إدخال النص والتحقق منه، نضغط على حفظ.
يمكننا حذف كلمة المرور الحالية بالضغط على زر حذف كلمة المرور.
كما يمكننا تجربتها بالضغط على زر تشغيل كلمة المرور.
عند تشغيلها، يجب أن نكون في شاشة القفل.
ملاحظات:
هذه الميزة قد تفقدك خصوصيتك، بحيث إذا كان بجانبك شخص ورأى ما فعلت يمكنه أن يقوم بنفس الإيماءة ويؤدي نفس الأمر الصوتي من أجل فتح هاتفك.
وإذا كانت كلمة المرور لا تعمل على هاتفك، فيرجى إرسال اسم العقدة الخاص بشاشة كلمة المرور، وهو اسم العنوان الذي يظهر على الشاشة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
end