utf8 = require("utf8")

function removeBracketInfoFromLines(text)
    local modified = false
    local lines = {}
    for line, ending in text:gmatch("([^\r\n]*)([\r\n]?)") do
        if line == "" and ending == "" then break end
        line = line:gsub("  %[", ". [")
        local newLine = line:gsub(" ?%[.-%].*$", function()
            modified = true
            return ""
        end)
        table.insert(lines, newLine .. ending)
    end
    return table.concat(lines), modified
end

local node = service.getEditText()
if node then
    local text = service.getText(node)
    local newText, changed = removeBracketInfoFromLines(text)
    if changed then
        service.setText(node, newText .. "\n")
                service.postSpeak(200,"تم إزالة معلومات الآيات.")
    else
        service.postSpeak(200,"لا توجد معلومات للآيات لإزالتها.")
    end
else
    service.speak("لا يوجد مربع تحرير في الشاشة الحالية.")
end 