local node = service.getEditText()
local text = service.getText(node)

-- تأكد من وجود النص
if not text or text == "" then
  service.postError("لا يوجد نص لحفظه.")
  return
end

-- إنشاء المجلد إذا لم يكن موجودًا
local folderPath = "/storage/emulated/0/Documents/الإملاء المريح/"
io.mkdir(folderPath)

local extension = ".txt"

-- استخراج أول أربع كلمات من النص لاسم الملف
local namePart = ""
local wordCount = 0
for word in string.gmatch(text, "%S+") do
    namePart = namePart .. word .. " "
    wordCount = wordCount + 1
    if wordCount == 4 then break end
end

-- إزالة المسافة الأخيرة واستبدال الأحرف غير المناسبة
namePart = namePart:match("^%s*(.-)%s*$")
namePart = namePart:gsub("[\\/:*?\"<>|]", "_")

-- التأكد من عدم تكرار الاسم
local counter = 1
local fileName = namePart .. extension
local filePath = folderPath .. fileName
while io.open(filePath, "r") do
    fileName = namePart .. "_" .. counter .. extension
    filePath = folderPath .. fileName
    counter = counter + 1
end

-- حفظ النص في الملف
local file = io.open(filePath, "w+")
if file then
    file:write(text)
    file:close()
    service.postSpeak(500, "تم حفظُ ملف: " .. fileName .. " في مُجَلَّدْ Documents/الإملاء المريح")
else
    service.postSpeak(500, "فشل في حفظ الملف.")
end